function J = bcaBootfunc(X,use)
% usage: J = bcaBootfunc(X,use)
% X=[x,y], use = 'kICA', 'skew', tai 'tanh'

% with kernelICA
if all(use=='kICA')
    x = X(:,1); y = X(:,2);
    s = regstats(x,y);
    Jy = my_call_contrast([s.r';y']);
    s = regstats(y,x);
    Jx = my_call_contrast([s.r';x']);
    J = Jy - Jx;

elseif all(use=='skew')
    x = zscore(X(:,1)); y = zscore(X(:,2));
    x = sign(skewness(x))*x; y = sign(skewness(y))*y;    
    phi = corr(x,y); J = phi*mean(x.^2.*y - x.*y.^2);

elseif all(use=='tanh')
    x = zscore(X(:,1)); y = zscore(X(:,2));
    phi = corr(x,y); J = phi*mean(x.*tanh(y) - tanh(x).*y);
else
    error('use must be kICA, skew, or tanh')
end